Draft Text: Difference between revisions

From FreeCAD Documentation
("Hold" instead of "press")
No edit summary
(20 intermediate revisions by 6 users not shown)
Line 1: Line 1:
<languages/>
<languages/>
<translate>
<translate>
<!--T:18-->
{{Docnav
|[[Draft_Rectangle|Rectangle]]
|[[Draft_Dimension|Dimension]]
|[[Draft_Module|Draft]]
|IconL=Draft_Rectangle.svg
|IconR=Draft_Dimension.svg
|IconC=Workbench_Draft.svg
}}

<!--T:1-->
<!--T:1-->
{{GuiCommand
{{GuiCommand
|Name=Draft Text
|Name=Draft Text
|MenuLocation=Draft → Text
|MenuLocation=Draft → Text
|Workbenches=[[Draft Module|Draft]], [[Arch Module|Arch]]
|Workbenches=[[Draft_Module|Draft]], [[Arch_Module|Arch]]
|Shortcut=T E
|Shortcut={{KEY|T}} {{KEY|E}}
|Version=0.7
|SeeAlso=[[Draft Label]], [[Draft ShapeString]]
|SeeAlso=[[Draft_Label|Draft Label]], [[Draft_ShapeString|Draft ShapeString]]
|Version=0.7}}
}}


==Description== <!--T:2-->
==Description== <!--T:22-->

The Text tool inserts a multi-line textbox at a given point. It uses the [[Draft Linestyle]] set on the [[Draft Tray]].
<!--T:2-->
The {{Button|[[Image:Draft_Text.svg|16px]] [[Draft_Text|Draft Text]]}} tool inserts a multi-line textbox at a given point. It uses the [[Draft_Linestyle|Draft Linestyle]] set on the [[Draft_Tray|Draft Tray]].


<!--T:11-->
<!--T:11-->
To create a text label with a leader and an arrow use [[Draft Label]]. To create solid text or 3D letters use [[Draft ShapeString]] with [[Part Extrude]].
'''Alternatively:''' To create a text label with a leader and an arrow use [[Draft Label|Draft Label]]. To create solid text or 3D letters use [[Draft ShapeString|Draft ShapeString]] with [[Part Extrude|Part Extrude]].


<!--T:3-->
<!--T:3-->
[[Image:Draft_Text_example.jpg|400px]]
[[Image:Draft_Text_example.png|400px]]
{{Caption|Single point required to position the textbox}}

<!--T:21-->
'''Warning:''' The texts created with [[Release notes 0.18 |version 0.18]] are not backward compatible, so backup your work if you try to open files created with 0.18 with older versions.

==Usage== <!--T:23-->


==How to use== <!--T:4-->
<!--T:4-->
# Press the {{Button|[[Image:Draft Text.png|16px]] [[Draft Text]]}} button, or press {{KEY|T}} then {{KEY|E}} keys.
# Press the {{Button|[[Image:Draft_Text.svg|16px]] [[Draft Text|Draft Text]]}} button, or press {{KEY|T}} then {{KEY|E}} keys.
# Click a point on the 3D view, or type a [[Draft_Coordinates|coordinate]] and press the {{Button|[[Image:Draft_AddPoint.svg|16px]] [[Draft_AddPoint|add point]]}} button.
# Click a point on the 3D view, or type a [[Draft_Coordinates|coordinate]] and press the {{Button|[[Image:Draft_AddPoint.svg|16px]] [[Draft_AddPoint|add point]]}} button.
# Enter the desired text, pressing {{KEY|Enter}} between each line.
# Enter the desired text, pressing {{KEY|Enter}} between each line.
Line 29: Line 48:
<!--T:6-->
<!--T:6-->
* To enter coordinates manually, simply enter the numbers, then press {{KEY|Enter}} between each X, Y and Z component. You can press the {{Button|[[Image:Draft_AddPoint.svg|16px]] [[Draft_AddPoint|add point]]}} button when you have the desired values to insert the point.
* To enter coordinates manually, simply enter the numbers, then press {{KEY|Enter}} between each X, Y and Z component. You can press the {{Button|[[Image:Draft_AddPoint.svg|16px]] [[Draft_AddPoint|add point]]}} button when you have the desired values to insert the point.
* Hold {{KEY|Ctrl}} while inserting the text to force [[Draft_Snap|snapping]] your point to the nearest snap location, independently of the distance.
* Hold {{KEY|Ctrl}} while placing the text to force [[Draft_Snap|snapping]] your point to the nearest snap location, independently of the distance.
* Press {{KEY|Enter}} or {{KEY|↓ Down arrow}} to enter a new line of text.
* Press {{KEY|Enter}} or {{KEY|↓ Down arrow}} to enter a new line of text.
* Press {{KEY|↑ Up arrow}} to edit the previous line of text.
* Press {{KEY|↑ Up arrow}} to edit the previous line of text.
Line 37: Line 56:
==Properties== <!--T:7-->
==Properties== <!--T:7-->


=== Data ===
=== Data === <!--T:12-->
* {{PropertyData|Text}}: specifies the contents of the text block as a list of strings; each element on the list, separated by a comma, indicates a new line.
* {{PropertyData|Text}}: specifies the contents of the text block as a list of strings; each element on the list, separated by a comma, indicates a new line.
* {{PropertyData|Position}}: specifies the base point of the first line of the text block.
* {{PropertyData|Position}}: specifies the base point of the first line of the text block.
Line 43: Line 62:
* {{PropertyData|Axis}}: specifies the axis to use for the rotation.
* {{PropertyData|Axis}}: specifies the axis to use for the rotation.


=== View ===
=== View === <!--T:13-->
* {{PropertyView|Display Mode}}: if it is "3D text" the text will be aligned to the scene axes, initially lying on the XY plane; if it is "2D text" the text will always face the camera.
* {{PropertyView|Display Mode}}: if it is "3D text" the text will be aligned to the scene axes, initially lying on the XY plane; if it is "2D text" the text will always face the camera.
* {{PropertyView|Font Name}}: specifies the font to use to draw the text. It can be a font name, such as "Arial", a default style such as "sans", "serif" or "mono", a family such as "Arial,Helvetica,sans" or a name with a style such as "Arial:Bold". If the given font is not found on the system, a generic one is used instead.
* {{PropertyView|Font Name}}: specifies the font to use to draw the text. It can be a font name, such as "Arial", a default style such as "sans", "serif" or "mono", a family such as "Arial,Helvetica,sans" or a name with a style such as "Arial:Bold". If the given font is not found on the system, a generic one is used instead.
Line 51: Line 70:


==Scripting== <!--T:8-->
==Scripting== <!--T:8-->
{{Emphasis|See also:}} [[Draft API]] and [[FreeCAD Scripting Basics]].
{{Emphasis|See also:}} [[Draft API|Draft API]] and [[FreeCAD Scripting Basics|FreeCAD Scripting Basics]].


<!--T:14-->
The Text tool can be used in [[macros]] and from the [[Python]] console by using the following function:
The Text tool can be used in [[macros|macros]] and from the [[Python|Python]] console by using the following function:
</translate>
</translate>
{{Code|code=
{{Code|code=
Line 64: Line 84:
* If {{incode|screen}} is {{incode|True}}, the text always faces the camera view direction, otherwise it aligns with the scene axes, and lies on the XY plane.
* If {{incode|screen}} is {{incode|True}}, the text always faces the camera view direction, otherwise it aligns with the scene axes, and lies on the XY plane.


<!--T:15-->
The placement of the {{incode|Text}} can be changed by overwriting its {{incode|Placement}} attribute, or by individually overwriting its {{incode|Placement.Base}} and {{incode|Placement.Rotation}} attributes.
The placement of the {{incode|Text}} can be changed by overwriting its {{incode|Placement}} attribute, or by individually overwriting its {{incode|Placement.Base}} and {{incode|Placement.Rotation}} attributes.


<!--T:16-->
The view properties of {{incode|Text}} can be changed by overwriting its attributes; for example, overwrite {{incode|ViewObject.FontSize}} with the new size in millimeters.
The view properties of {{incode|Text}} can be changed by overwriting its attributes; for example, overwrite {{incode|ViewObject.FontSize}} with the new size in millimeters.


Line 99: Line 121:
Text4.Placement.Rotation = FreeCAD.Rotation(ZAxis, -30)
Text4.Placement.Rotation = FreeCAD.Rotation(ZAxis, -30)
}}
}}
<translate>

<!--T:17-->
{{Docnav
|[[Draft_Rectangle|Rectangle]]
|[[Draft_Dimension|Dimension]]
|[[Draft_Module|Draft]]
|IconL=Draft_Rectangle.svg
|IconR=Draft_Dimension.svg
|IconC=Workbench_Draft.svg
}}

</translate>
{{Draft Tools navi{{#translation:}}}}
{{Userdocnavi{{#translation:}}}}
{{clear}}
{{clear}}
{{Draft Tools navi}}
{{Userdocnavi}}
[[Category:Draft]]

Revision as of 15:49, 29 November 2020

Draft Text

Menu location
Draft → Text
Workbenches
Draft, Arch
Default shortcut
T E
Introduced in version
0.7
See also
Draft Label, Draft ShapeString

Description

The Draft Text tool inserts a multi-line textbox at a given point. It uses the Draft Linestyle set on the Draft Tray.

Alternatively: To create a text label with a leader and an arrow use Draft Label. To create solid text or 3D letters use Draft ShapeString with Part Extrude.

Single point required to position the textbox

Warning: The texts created with version 0.18 are not backward compatible, so backup your work if you try to open files created with 0.18 with older versions.

Usage

  1. Press the Draft Text button, or press T then E keys.
  2. Click a point on the 3D view, or type a coordinate and press the add point button.
  3. Enter the desired text, pressing Enter between each line.
  4. Press Enter twice to finish the operation.

Options

  • To enter coordinates manually, simply enter the numbers, then press Enter between each X, Y and Z component. You can press the add point button when you have the desired values to insert the point.
  • Hold Ctrl while placing the text to force snapping your point to the nearest snap location, independently of the distance.
  • Press Enter or ↓ Down arrow to enter a new line of text.
  • Press ↑ Up arrow to edit the previous line of text.
  • Press Enter or ↓ Down arrow twice to finish editing the text.
  • Press Esc or the Close button to abort the current command.

Properties

Data

  • DataText: specifies the contents of the text block as a list of strings; each element on the list, separated by a comma, indicates a new line.
  • DataPosition: specifies the base point of the first line of the text block.
  • DataAngle: specifies the rotation of the baseline of the first line of the text block.
  • DataAxis: specifies the axis to use for the rotation.

View

  • ViewDisplay Mode: if it is "3D text" the text will be aligned to the scene axes, initially lying on the XY plane; if it is "2D text" the text will always face the camera.
  • ViewFont Name: specifies the font to use to draw the text. It can be a font name, such as "Arial", a default style such as "sans", "serif" or "mono", a family such as "Arial,Helvetica,sans" or a name with a style such as "Arial:Bold". If the given font is not found on the system, a generic one is used instead.
  • ViewFont Size: specifies the size of the letters. If the text object is created in the tree view but no text is visible, increase the size of the text until it is visible.
  • ViewJustification: specifies if the text aligns to the left, right or at the center of the base point.
  • ViewLine Spacing: specifies the space between lines of text.

Scripting

See also: Draft API and FreeCAD Scripting Basics.

The Text tool can be used in macros and from the Python console by using the following function:

Text = makeText(stringlist, point=Vector(0,0,0), screen=False)
  • Creates a Text object, at a point defined by a FreeCAD.Vector.
  • stringlist is a string, or a list of strings; if it's a list, each element is displayed in its own line.
  • If screen is True, the text always faces the camera view direction, otherwise it aligns with the scene axes, and lies on the XY plane.

The placement of the Text can be changed by overwriting its Placement attribute, or by individually overwriting its Placement.Base and Placement.Rotation attributes.

The view properties of Text can be changed by overwriting its attributes; for example, overwrite ViewObject.FontSize with the new size in millimeters.

Example:

import FreeCAD, Draft

p1 = FreeCAD.Vector(0, 0, 0)
t1 = "This is a sample text"

p2 = FreeCAD.Vector(1000, 1000, 0)
t2 = ["First line", "second line"]

Text1 = Draft.makeText(t1, point=p1)
Text2 = Draft.makeText(t2, point=p2)
Text1.ViewObject.FontSize = 200
Text2.ViewObject.FontSize = 200

p3 = FreeCAD.Vector(-1000, -500, 0)
t3 = ["Upside", "down"]

Text3 = Draft.makeText(t3, point=p3)
Text3.ViewObject.FontSize = 200

ZAxis = FreeCAD.Vector(0, 0, 1)
place3 = FreeCAD.Placement(p3, FreeCAD.Rotation(ZAxis, 175))
Text3.Placement = place3

Text4 = Draft.makeText(t3, point=p3)
Text4.ViewObject.FontSize = 200
Text4.Placement.Rotation = FreeCAD.Rotation(ZAxis, -30)